<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\EscopoFaturamentoService;
use SM\Traits\TResponse;

class EscopoFaturamentoController extends SMCrud
{
    use TResponse;

    protected $EscopoFaturamentoService;

    public function __construct($crudService, $environment, EscopoFaturamentoService $EscopoFaturamentoService)
    {
        parent::__construct($crudService, $environment);
        $this->EscopoFaturamentoService = $EscopoFaturamentoService;
    }

    public function editEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->editEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveAddEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveAddEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function deleteEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabelaPrecoEscopoFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getTabelaPrecoEscopoFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getMoedaTabelaPrecoEscopoFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getMoedaTabelaPrecoEscopoFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getPrecBaseServTabelaPrecoEscopoFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getPrecBaseServTabelaPrecoEscopoFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
    
    public function getPrecBaseTabelaPrecoEscopoFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getPrecBaseTabelaPrecoEscopoFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveTabelaPreco(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveTabelaPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function deleteTabPrecEscopoFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteTabPrecEscopoFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function getItEscopoProposta(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getItEscopoProposta($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 
    
    public function getParamFatItEsc(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getParamFatItEsc($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 
    
    public function saveServEscTabParamFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveServEscTabParamFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function deleteServEscTabParamFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteServEscTabParamFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveServEscTabCompetencia(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveServEscTabCompetencia($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function deleteServEscTabCompetencia(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteServEscTabCompetencia($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getEspFatServicoOrca(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getEspFatServicoOrca($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function saveEscFatServicoEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveEscFatServicoEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteEscFatItServicoEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteEscFatItServicoEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getCapaParamFatEsc(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getCapaParamFatEsc($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function saveCapaParametrosFaturamento(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveCapaParametrosFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteCapaParametrosFaturamento(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteCapaParametrosFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveParamFatCompetencia(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveParamFatCompetencia($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
    
    public function deleteParamFatCompetencia(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteParamFatCompetencia($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTipoMedidaVariavelParamFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getTipoMedidaVariavelParamFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getProdutoParaFaturamentoParamFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getProdutoParaFaturamentoParamFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function getFilialParamFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getFilialParamFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function getTipoOperacParamFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getTipoOperacParamFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getSerieNotaParamFat(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getSerieNotaParamFat($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function getParamfatitescserv(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getParamfatitescserv($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
    
    public function getParamfatesc(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getParamfatesc($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function getDescAgrupEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getDescAgrupEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getIndicesPadrEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getIndicesPadrEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveIndicesFinanceirosPadrEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveIndicesFinanceirosPadrEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteParametrosIndicePadrEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteParametrosIndicePadrEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveEscFatDescricaoEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->saveEscFatDescricaoEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function deleteEscFatDescricaoEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->deleteEscFatDescricaoEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getRelacAgrupTipoOrcaEscopo(Request $request)
    {
        try {
            $data = $this->EscopoFaturamentoService->getRelacAgrupTipoOrcaEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
}